ICode9

精准搜索请尝试: 精确搜索
首页 > 其他分享> 文章详细

HDU1074字典序+状压

2021-03-21 11:02:27  阅读:146  来源: 互联网

标签:int 状压 cost dp English test HDU1074 Math 字典


题干

Problem Description
Ignatius has just come back school from the 30th ACM/ICPC. Now he has a lot of homework to do. Every teacher gives him a deadline of handing in the homework. If Ignatius hands in the homework after the deadline, the teacher will reduce his score of the final test, 1 day for 1 point. And as you know, doing homework always takes a long time. So Ignatius wants you to help him to arrange the order of doing homework to minimize the reduced score.

Input
The input contains several test cases. The first line of the input is a single integer T which is the number of test cases. T test cases follow.
Each test case start with a positive integer N(1<=N<=15) which indicate the number of homework. Then N lines follow. Each line contains a string S(the subject’s name, each string will at most has 100 characters) and two integers D(the deadline of the subject), C(how many days will it take Ignatius to finish this subject’s homework).

Note: All the subject names are given in the alphabet increasing order. So you may process the problem much easier.

Output
For each test case, you should output the smallest total reduced score, then give out the order of the subjects, one subject in a line. If there are more than one orders, you should output the alphabet smallest one.

Sample Input
2
3
Computer 3 3
English 20 1
Math 3 2
3
Computer 3 3
English 6 3
Math 6 3

Sample Output
2
Computer
Math
English
3
Computer
English
Math

Hint

In the second test case, both Computer->English->Math and Computer->Math->English leads to reduce 3 points, but the
word “English” appears earlier than the word “Math”, so we choose the first order. That is so-called alphabet order.

题意

就是每个作业一个消耗时间和截止时间,问怎么做最后超时数最少

思路

状压

状压的遍历顺序是1 10 11 100 101 110 111。。。
换而言之每次出现一种新状态的时候就用之前的状态作转移
其思路类似背包 所以又叫状压dp
这题为了保证字典序最小的结果 由于输入的时候数据已经是字典序最小了
所以我们在更新状态的时候从后往前
比如1011在更新的时候先从0011转移 然后从1001转移 最后从1010转移
这样就保证新状态是字典序最小
至于状态转移
当前状态存的是已经做了哪几门作业
于是用dp存做了的这几门作业已经扣了的学分就行了
为了输出做作业的顺序,还要在状态转移的时候存一下上一个状态

代码

#include<bits/stdc++.h>
using namespace std;
const int inf=0x3f3f3f3f;
struct node{
	int cost;
	int ddl;
	string name;
}s[30];
struct state{
	int cost;
	int last;
	int time;
}dp[40000];
stack<string> q;
int main(){
	int t;
	cin>>t;
	while(t--){
		int n;
		cin>>n;
		for(int i=1;i<=n;i++)
		cin>>s[i].name>>s[i].ddl>>s[i].cost;//输入 
		
		int maxi=(1<<n)-1;
		for(int i=1;i<=maxi;i++){
		dp[i].cost=inf;dp[i].time=0;}
		dp[0].cost=0;dp[0].last=-1;//初始化 
		
		for(int i=1;i<=maxi;i++){//dp 
			int now=i;
			for(int j=n;j>=1;j--){
				int temp=1<<(j-1);
				if((now&temp)==0)continue;
				int last=now-temp;
				int time=dp[last].time+s[j].cost-s[j].ddl;
				if(time<0)time=0;
				if(dp[now].cost>dp[last].cost+time){
				dp[now].cost=dp[last].cost+time;
				dp[now].time=dp[last].time+s[j].cost;
				dp[now].last=j;	
				}
			}
		}
		
		int ans=maxi;
		cout<<dp[ans].cost<<endl;
		while(ans){//输出 
			int last=dp[ans].last;
			q.push(s[last].name);
			ans-=(1<<(last-1));
		}
		while(q.size()){
			cout<<q.top()<<endl;
			q.pop();
		}
	}
	return 0;
} 

标签:int,状压,cost,dp,English,test,HDU1074,Math,字典
来源: https://blog.csdn.net/yukiiiiiiiiia/article/details/115043001

本站声明: 1. iCode9 技术分享网(下文简称本站)提供的所有内容,仅供技术学习、探讨和分享;
2. 关于本站的所有留言、评论、转载及引用,纯属内容发起人的个人观点,与本站观点和立场无关;
3. 关于本站的所有言论和文字,纯属内容发起人的个人观点,与本站观点和立场无关;
4. 本站文章均是网友提供,不完全保证技术分享内容的完整性、准确性、时效性、风险性和版权归属;如您发现该文章侵犯了您的权益,可联系我们第一时间进行删除;
5. 本站为非盈利性的个人网站,所有内容不会用来进行牟利,也不会利用任何形式的广告来间接获益,纯粹是为了广大技术爱好者提供技术内容和技术思想的分享性交流网站。

专注分享技术,共同学习,共同进步。侵权联系[81616952@qq.com]

Copyright (C)ICode9.com, All Rights Reserved.

ICode9版权所有